


var fpbthd_contract_id = "@mozilla.org/bittorrenthelperdialog;1";
var fpbthd_class_id = "{d9746fb6-cc81-4677-951e-8d0bd5ef42c4}";


function nsBitTorrentHelperDialog() {
	this.torrent  = null;
	this.mdlg = null;
	this.state = 0;
}


nsBitTorrentHelperDialog.prototype = {

	QueryInterface: function (iid) {
		if (!iid.equals(Components.interfaces.nsISupports) &&
			!iid.equals(Components.interfaces.nsIBitTorrentHelperDialog) &&
			!iid.equals(Components.interfaces.nsIObserver)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},

	observe: function (subject, topic, data) {
		switch (topic) {
			case '2':
				break;
		}

	},

	init: function(aTorrent) {
		this.torrent = aTorrent;
	},

	show: function() {
		var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
		this.mdlg = ww.openWindow(null, "chrome://firepuddle/content/helperDlg.xul", null, "chrome,titlebar,dialog=yes", null);
		this.mdlg.helper = this;

	},
	
	onLoad: function() {
	
			var panelopen = this.mdlg.document.getElementById("panelopen");
			panelopen.setAttribute('style', 'display: none');
			var panelsave = this.mdlg.document.getElementById("panelsave");
			panelsave.setAttribute('style', 'display: none');
			var panelinfo = this.mdlg.document.getElementById("panelinfo");
			panelinfo.setAttribute('style', 'display: none');

		if (!this.torrent) {
			this.state = 1;
			// stage let user specify torrent
			panelopen.setAttribute('style', 'display: block');
		} else
		{
			this.state = 2;
			panelinfo.setAttribute('style', 'display: block');
			// stage download/parse torrent
			// todo use E4X
			var infolabel = this.mdlg.document.getElementById("infolabel");
			infolabel.setAttribute('value', 'Downloading and parsing .torrent file');
		}
	
	},

	onParseDone: function() {
		//

				if (this.torrent.lastError) {
					// NOT GOOD
					alert('parse torrent error');
				}
				// give the torrent a target directory
				//this.torrent.targetDir = this.dir;

			var panelsave = this.mdlg.document.getElementById("panelsave");
			panelsave.setAttribute('style', 'display: block');
			var panelinfo = this.mdlg.document.getElementById("panelinfo");
			panelinfo.setAttribute('style', 'display: none');
			this.state = 3;
			
			var torrentname = this.mdlg.document.getElementById("torrentname");
			torrentname.value = this.torrent.infoName;
			
			//var torrentsize = this.mdlg.document.getElementById("torrentsize");
			//torrentsize.value = this.torrent.infoName;
				// start the download
				//alert('parse done');
				//this.torrent.resumeTorrent();
	},

	onVerifyDone: function() {
		//
				
				if (this.torrent.lastError) {
					// NOT GOOD
					alert('verify torrent progress error');
				}
			var panelsave = this.mdlg.document.getElementById("panelsave");
			panelsave.setAttribute('style', 'display: none');
			var panelinfo = this.mdlg.document.getElementById("panelinfo");
			panelinfo.setAttribute('style', 'display: block');
			var infolabel = this.mdlg.document.getElementById("infolabel");
			infolabel.setAttribute('value', 'Click OK to start downloading the torrent');
				//this.torrent.addFirefoxDownload();
				//this.torrent.resumeTorrent();
			this.state = 5;

	},

	onOK: function() {
		switch(this.state) {
			case 1:
				this.state = 2;
							var panelopen = this.mdlg.document.getElementById("panelopen");
			panelopen.setAttribute('style', 'display: none');
			var panelsave = this.mdlg.document.getElementById("panelsave");
			panelsave.setAttribute('style', 'display: none');
			var panelinfo = this.mdlg.document.getElementById("panelinfo");
			panelinfo.setAttribute('style', 'display: block');
				var infolabel = this.mdlg.document.getElementById("infolabel");
				infolabel.setAttribute('value', 'Downloading and parsing .torrent file');

				
				// start parsing torrent
				this.btsvc = Components.classes["@mozilla.org/nsbittorrentservice;1"].getService().QueryInterface(Components.interfaces.nsIBitTorrentService);
				this.btsvc.startDownload(torrenturl.value, this);
				break;
			case 3:
				var panelopen = this.mdlg.document.getElementById("panelopen");
				panelopen.setAttribute('style', 'display: none');
				var panelsave = this.mdlg.document.getElementById("panelsave");
				panelsave.setAttribute('style', 'display: none');
				var panelinfo = this.mdlg.document.getElementById("panelinfo");
				panelinfo.setAttribute('style', 'display: block');
				var infolabel = this.mdlg.document.getElementById("infolabel");
				infolabel.setAttribute('value', 'Verifying existing file. Please wait...');
				var destdir = this.mdlg.document.getElementById("destdir");
						
				var torrenturl = this.mdlg.document.getElementById("torrenturl");

				var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				dir.QueryInterface(Components.interfaces.nsILocalFile);
				dir.initWithPath(destdir.value);
				if (!dir.isDirectory()) { alert('Error torrentsavedir does not exist or isn\'t a directory.'); return; }

				this.torrent.targetDir = dir;
			
				// start the verify
				this.torrent.resumeTorrent();
				this.state = 4;
				break;
			case 5:
				// start actual download
				this.torrent.addFirefoxDownload();
				this.torrent.resumeTorrent();
				
				this.mdlg.helper = null;

				return true;
				break;
		}
		return false;
	},

	onCancel: function() {
		//
		this.mdlg.helper = null;
		return true;
	},
	
	onBlur: function(event) {
	
	},
	
	onFocus: function(event) {
	
	}

}


// This Component's module implementation.  All the code below is used to get this
// component registered and accessible via XPCOM.
var module = {
	firstTime: true,

	/* CID for this class */
	cid: Components.ID(fpbthd_class_id),

	/* Contract ID for this class */
	contractId: fpbthd_contract_id,

	// registerSelf: Register this component.
	registerSelf: function (compMgr, fileSpec, location, type) {
		if (this.firstTime) {
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		//compMgr.registerComponentWithType( this.cid, "NetUsage Component", this.contractId, fileSpec, location, true, true, type);
		compMgr.registerFactoryLocation(this.cid, "FirePuddle BT Helper Dialog", this.contractId, fileSpec, location, type);

		//var catman = Components.classes["@mozilla.org/categorymanager;1"].getService().QueryInterface(Components.interfaces.nsICategoryManager);
		//catman.addCategoryEntry("xpcom-startup", "NetUsage", nuc_contract_id, true, true);
	},

	// getClassObject: Return this component's factory object.
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.cid)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}

		if (!iid.equals(Components.interfaces.nsIFactory)) {
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.factory;
	},

	/* factory object */
	factory: {
		createInstance: function (outer, iid) {
			if (outer != null)
				throw Components.results.NS_ERROR_NO_AGGREGATION;

			var obj = new nsBitTorrentHelperDialog();
			// a service
			return obj.QueryInterface(iid);
		}
	},

	// canUnload: n/a (returns true)
	canUnload: function(compMgr) {
		return true;
	}
};

// NSGetModule: Return the nsIModule object.
function NSGetModule(compMgr, fileSpec) {
	return module;
}